package mi.hdm.controllers;

import javafx.fxml.FXML;
import javafx.scene.control.CheckBox;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.layout.AnchorPane;
import javafx.scene.layout.VBox;
import mi.hdm.components.IngredientLabel;
import mi.hdm.recipes.Ingredient;
import mi.hdm.recipes.IngredientManager;
import mi.hdm.recipes.Measurement;
import mi.hdm.recipes.RecipeManager;
import mi.hdm.shoppingList.ShoppingList;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import java.util.Map;

public class ShoppingListViewController extends BaseController {
    private static final Logger log = LogManager.getLogger(ShoppingListViewController.class);

    private final RecipeManager recipeManager;
    private final ShoppingList shoppingList;
    private final IngredientManager ingredientManager;

    @FXML
    private AnchorPane parent;
    @FXML
    private VBox shoppingListRecipes;
    @FXML
    private VBox shoppingListIngredients;
    @FXML
    private TextField ingredientSearch;


    public ShoppingListViewController(RecipeManager recipeManager, ShoppingList shoppingList, IngredientManager ingredientManager) {
        this.recipeManager = recipeManager;
        this.shoppingList = shoppingList;
        this.ingredientManager = ingredientManager;
    }

    @FXML
    public void changeSceneToMain() {
        try {
            changeScene(View.MAIN);
        } catch (Exception e) {
            e.printStackTrace();
            log.error("Something went wrong when changing the scene.");
        }
    }
    //TODO: this page does rarely anything
    @FXML
    public void initialize() {

        loadHeader(parent);
        shoppingList.getList().forEach((code, status) -> {
            Ingredient i = ingredientManager.getIngredient(code).orElseThrow();
            String name = i.getName();
            Label ingredientLabel = new Label(name);
            CheckBox check = new CheckBox();
            shoppingListIngredients.getChildren().addAll(ingredientLabel, check);
        });
    }

    @FXML
    public void handleClearList() {
        shoppingList.clear();
        log.info("ShoppingList cleared successfully.");
    }

    @FXML
    public void handleAddIngredient() {

    }

    @FXML
    public void handleAddRecipe() {

    }

    @FXML
    public void searchIngredients() {
        /*
        String input = ingredientSearch.getText();
        log.debug("Input in search field changed, searching through recipe components with query '{}'.", input);
        searchResults = recipeSearch.searchThroughNames(input);
        currentPage = 0;
        maxPages = searchResults.size() / ELEMENTS_PER_SEARCH_PAGE;
        drawIngredientSearchResults();
        */
    }

    @FXML
    public void searchRecipe() {}
}
